#!/usr/bin/python
# -*- coding: utf-8 -*-

#
# Copyright (C) Big-Cat Software Association, 2007.
#
# GILDE project. 
# (Graphical Interfaces to Learn Debian Easily)
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version. Please read the COPYING file.
#
# 
# Copyright (C) 2005 by S.Çağlar Onur <caglar@uludag.org.tr>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the
# Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

''' Standart Python Modules '''
import os
import sys
import array
import fcntl
import socket
import struct


image0_data = \
    "\x89\x50\x4e\x47\x0d\x0a\x1a\x0a\x00\x00\x00\x0d" \
    "\x49\x48\x44\x52\x00\x00\x00\x20\x00\x00\x00\x20" \
    "\x08\x06\x00\x00\x00\x73\x7a\x7a\xf4\x00\x00\x02" \
    "\xf1\x49\x44\x41\x54\x58\x85\xed\xd6\x4b\x88\x96" \
    "\x75\x14\x06\xf0\xdf\xe7\x68\x53\xea\x94\x46\xa1" \
    "\x81\x9a\x8a\x65\x52\x24\x76\xc7\x34\x23\x89\x04" \
    "\xb1\x4d\xd8\xa2\x45\x64\x14\x48\x48\xd4\x2a\x28" \
    "\x57\xb6\x88\x36\x15\x81\x8b\xda\x14\xda\x6e\x4c" \
    "\xbc\x20\x84\xda\x4d\xa2\x12\x14\x84\x89\x34\x15" \
    "\x33\x8b\xee\x8e\x76\x99\x2e\xce\x34\x5f\x8b\x73" \
    "\x3e\xfd\x7c\xfd\xee\x4d\x6d\xf2\x81\x77\xf1\x5e" \
    "\xce\x39\xcf\xff\xf9\x3f\xe7\xfc\x5f\xce\xe3\xff" \
    "\x8e\x52\x07\x31\xa3\x30\x03\xb3\x71\x19\x46\xe3" \
    "\x38\x8e\xe2\x53\x0c\x8e\x14\xb9\x22\xae\xc4\xb3" \
    "\xd8\x8f\xdf\xf1\x17\xca\x79\x0d\xe3\x4f\x7c\x8d" \
    "\x57\x31\x3f\x89\x8d\x08\x26\x62\x0d\xbe\xa9\x2a" \
    "\xd8\xec\xfa\x03\x1b\x70\xf5\x3f\x2d\x7e\x1b\x8e" \
    "\xd4\x29\xd2\x8f\x03\xf8\x44\xac\x7c\xb8\xce\x37" \
    "\x8f\xa0\xab\xdd\xc2\x25\xdc\x87\x1f\x0a\x09\x4f" \
    "\x62\x2d\xee\xc0\xe5\x18\x8f\x71\x42\xa5\xb9\x78" \
    "\x06\x07\x0b\x64\x4e\xe1\x39\x8c\x69\x87\xc0\x83" \
    "\x62\x9f\x2b\x49\x86\xb0\x0e\x73\x5a\x88\x9d\x80" \
    "\xd5\x18\x70\xb6\x47\x5e\xd0\xa2\x2f\x16\xe0\x97" \
    "\xaa\xe0\x01\x3c\x2a\xdc\x0f\xdd\xb8\x0a\xcb\xf0" \
    "\x58\xbe\x7b\x00\xd7\xe3\xa2\xaa\x3c\x37\xe1\xf3" \
    "\x02\x89\xa7\x34\xe9\xbc\xc9\xa2\x95\x2a\x41\x27" \
    "\x70\x6f\x06\x5d\x80\xc5\x42\x89\x5d\xf8\xb8\x70" \
    "\x7d\x80\x5e\x3c\x84\xb1\x99\x6f\x4e\x21\x5f\xbf" \
    "\xe8\x90\xd3\x28\x4a\x72\x67\x16\x22\xfa\xf9\x09" \
    "\x6c\xc1\x14\x3c\x8d\x1b\xaa\xbe\x1d\x16\x1e\xe9" \
    "\x42\x4f\x2a\x33\x15\x2b\x71\x17\x5e\xc6\x1e\xdc" \
    "\x8f\xed\x49\xea\x4d\x7c\x9b\x0b\x2a\xd7\x52\x60" \
    "\x02\x9e\x4c\xa6\x2f\x26\xc1\x6b\xb1\x29\x57\xf9" \
    "\x11\xde\x48\x55\x26\xe3\x42\x21\xfb\x44\xdc\x8d" \
    "\x97\xf0\x61\x7e\xfb\x3e\x96\x8a\xad\x5b\x82\xad" \
    "\x49\xb0\x29\xa6\x65\xf1\x71\x98\x8e\x6d\xce\x48" \
    "\xfc\x70\x3e\xaf\x87\x31\xc2\x1b\x6f\x65\xcc\xae" \
    "\x24\x56\xc2\xa2\x56\x8a\x13\xad\x35\x03\x17\xe3" \
    "\xb5\x4c\xf4\x0e\xee\x69\x35\x81\x18\xd3\x1b\x33" \
    "\x76\x07\x66\xa9\xd3\x01\xb5\x06\xc4\x20\x7e\xc2" \
    "\xe3\x58\x98\xcf\xd6\x0a\x2f\x10\x92\x4e\xcd\x77" \
    "\x8b\x71\x73\x12\x1e\xca\xb8\x61\x71\x36\xf4\xe5" \
    "\xfb\x1e\xe1\xab\xf7\x6a\x11\xa8\xc5\xaa\x62\x8e" \
    "\x49\x42\xba\x9d\x62\xac\x96\xc5\x7e\x2f\xc7\x8d" \
    "\x42\xee\x81\x2c\x78\x9d\x30\xf0\x7e\xd1\x09\xdf" \
    "\x09\xf7\xbf\x22\xda\xb4\xae\xf1\x1a\x8d\xc8\x83" \
    "\x99\xf8\xf9\x5c\xd9\xa5\x58\x85\x6b\xb0\x0f\xaf" \
    "\x63\x33\xde\xc6\x6e\x71\x38\xcd\x15\xfd\xff\x19" \
    "\x7e\xc6\x21\x61\xec\x5e\xfc\x56\xab\x48\x23\x02" \
    "\x43\x38\x9c\x44\xba\xb1\x42\x9c\x88\xbd\xc2\xd1" \
    "\x15\xb9\xcb\x99\xfc\x00\x8e\xe1\x96\x24\xde\x87" \
    "\x5f\xf1\x65\x2a\x52\x13\x8d\x08\x9c\xca\xc0\xb2" \
    "\x70\xf0\x42\xd1\x11\xef\xaa\xd3\xc3\xf8\x51\xc8" \
    "\x7d\xbb\x30\xf1\xbe\x24\x51\x17\xa3\x1a\xbd\x14" \
    "\x2b\x24\x14\x38\x22\xfc\x50\x5d\xbc\xcb\xb9\x3e" \
    "\xea\xc3\x5e\xb1\x55\x3d\x0d\xc8\x9e\x4e\xd0\x0a" \
    "\x0e\x0b\x35\x8e\xe7\x7d\x49\x9c\xf5\xf3\x30\x53" \
    "\xec\x73\xbf\xf0\x01\xa1\xc2\x78\x31\x09\x47\x1c" \
    "\x25\xdc\x2a\xc6\xf2\xe8\xbc\x9f\x2e\xc6\x6f\x77" \
    "\xe1\xbb\xa6\x68\xfb\x47\x01\x57\x88\xd1\xbb\xc7" \
    "\x99\x2d\x3a\x99\x64\x26\xe1\xfb\x0e\x72\xb6\x85" \
    "\xb1\xe2\x0c\x28\xa2\x4b\x18\xaf\x2d\x74\xa2\xc0" \
    "\xa0\x68\xd1\x4b\xc4\xa1\x54\x39\x70\xbe\x10\x3f" \
    "\xa6\xff\x19\x66\x8b\xff\xc1\x01\xac\xef\x34\x49" \
    "\xb3\x36\xfc\xd7\xd1\xc9\x16\x54\x30\x84\xaf\xc4" \
    "\xb0\xd9\x24\xa6\xe0\x79\xb4\x8d\xbf\x01\x26\x46" \
    "\xd4\xb2\xb1\xf9\x8d\x01\x00\x00\x00\x00\x49\x45" \
    "\x4e\x44\xae\x42\x60\x82"


''' Import Gettext Support '''
import gettext
__trans = gettext.translation('PyWireless', fallback=True)
_  =  __trans.ugettext

''' PyQt and PyKDE Modules'''
from qt import QToolTip, QTimer, QMessageBox, SIGNAL, QIconSet, QPixmap
from kdecore import KIcon, KIconLoader, KCmdLineArgs, KAboutData, KUniqueApplication, KStandardDirs
from kdeui import KSystemTray, KPopupMenu
from dcopexport import DCOPExObj

class WirelessStatus:

    ''' Signals '''
    SIOCGIWESSID = 0x8B1B # Get ESSID
    SIOCGIWMODE = 0x8B07  # Get Mode
    SIOCGIWRATE = 0x8B21  # Get Rate
    
    ''' Wireless Constans '''
    wKILO = 10**3
    wMEGA = 10**6
    wGIGA = 10**9

    ''' Byte constants '''
    bKILO = 2**10
    bMEGA = 2**20
    bGIGA = 2**30
    
    modes = ['Auto', 'Ad-Hoc', 'Managed', 'Master', 'Repeat', 'Second', 'Monitor']

    def __init__(self, parent):
# In order to calling functions from parent:
        self.parent=parent
# Active interface image
        self.image0 = QPixmap()
        self.image0.loadFromData(image0_data,"PNG")


        ''' Constuctor '''
        self.class_path = '/sys/class/net'
        self.selectedIfaceIndex = 0
        self.interfaceList=[]
        self.numberofIfaces=0
        self.device = self.findWirelessInterface()

        self.sockfd = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
        if not self.device:
            QMessageBox.information(None, _("No Wireless Interface"), _("You don't have any wireless interface..."), QMessageBox.Ok)
#            sys.exit(1)


# Check KWireless Tools Pro config dir:
        self.user_kwirelesstoolspro=os.path.expanduser("~/.kwirelesstoolspro")
        print self.user_kwirelesstoolspro

        if not os.path.exists(self.user_kwirelesstoolspro):
            os.mkdir(self.user_kwirelesstoolspro)


# Not safe, csere !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#    def findWirelessInterface(self):
        ''' Finds wireless interface '''
#        fileName = 'wireless'
#        for interface in os.listdir(self.class_path):
#            if os.path.exists(os.path.join(self.class_path, interface, fileName)):
#                return interface


## NEW version
# List of all interface, return first
    def findWirelessInterface(self):
        self.interfaceList=[]
        ''' Finds wireless interface '''
        fileName = 'wireless'
        interfaceExists=0
        for interface in os.listdir(self.class_path):
            if os.path.exists(os.path.join(self.class_path, interface, fileName)):
                self.interfaceList.append(interface)
                interfaceExists=1
        if interfaceExists==1:
            self.numberofIfaces=len(self.interfaceList)
            print "numberofIfaces", self.numberofIfaces
            return self.interfaceList[self.selectedIfaceIndex]
        else:
            self.numberofIfaces=0


    def returnInterfaceStatus(self):
        fileName = 'carrier'
        try:
            self.status = file(os.path.join(self.class_path, self.device, fileName)).readline().strip()
        except IOError:
            return 0
        return self.status

    def returnInterfaceName(self):
        ''' Returns the wireless interface name '''
        return self.device

    def returnLinkStatus(self):
        ''' Returns wireless link status % '''
        fileName = 'wireless/link'
        self.link = file(os.path.join(self.class_path, self.device, fileName)).readline().strip()
        return int(self.link)
    
    def returnNoiseStatus(self):
        ''' Returns current noise level '''
        fileName = 'wireless/noise'
        self.noise = file(os.path.join(self.class_path, self.device, fileName)).readline().strip()
        return int(self.noise) - 256

    def returnSignalStatus(self):
        ''' Returns current signal level '''
        fileName = 'wireless/level'
        self.signal = file(os.path.join(self.class_path, self.device, fileName)).readline().strip()
        return int(self.signal) - 256

    def returnReceived(self):
        ''' Returns received bytes '''
        fileName = 'statistics/rx_bytes'
        self.rx = int(file(os.path.join(self.class_path, self.device, fileName)).readline().strip())
 
        if self.rx >= self.bGIGA:
            return "%i Gb" %(self.rx/self.bGIGA)

        if self.rx >= self.bMEGA:
            return "%i Mb" %(self.rx/self.bMEGA)

        return "%i Kb" %(self.rx/self.bKILO)

    def returnTransferred(self):
        ''' Returns transferred bytes '''
        fileName = 'statistics/tx_bytes'
        self.tx = int(file(os.path.join(self.class_path, self.device, fileName)).readline().strip())
 
        if self.tx >= self.bGIGA:
            return "%i Gb" %(self.tx/self.bGIGA)

        if self.tx >= self.bMEGA:
            return "%i Mb" %(self.tx/self.bMEGA)

        return "%i Kb" %(self.tx/self.bKILO)

    def returnESSID(self):
        ''' Returns essid of interface '''
        buffer, structure = self.packRequest(32)
        i, result = self.readInformation(self.SIOCGIWESSID, structure)
        if i > 0:
            return result
        return buffer.tostring().strip('\x00')

    def returnBitrate(self):
        ''' Returns bit rate of interface '''
        i, result = self.readInformation(self.SIOCGIWRATE)
        if i > 0:
            return result

        size = struct.calcsize('ihbb')
        m, e, i, pad = struct.unpack('ihbb', result[:size])
        if e == 0:
            bitrate =  m
        else:
            bitrate = float(m) * 10**e

        if bitrate >= self.wGIGA:
            return "%i Gb/s" %(bitrate/self.wGIGA)

        if bitrate >= self.wMEGA:
            return "%i Mb/s" %(bitrate/self.wMEGA)

        if bitrate >= self.wKILO:
            return "%i Kb/s" %(bitrate/self.wKILO)

    def returnMode(self):
        ''' Returns operation mode of interface '''
        i, result = self.readInformation(self.SIOCGIWMODE)
        if i > 0:
            return result
        mode = self.unpackRequest('i', result[:4])[0]
        return self.modes[mode]

    ''' Internal Methods '''

    def packRequest(self, bufferSize):
        """ Packs wireless request data for sending it to the kernel """
        buffer = array.array('c', '\0' * bufferSize)
        caddr_t, length = buffer.buffer_info()
        structure = struct.pack('Pi', caddr_t, length)
        return buffer, structure

    def unpackRequest(self, format, packedRequest):
        """ Unpacks request with given format """
        return struct.unpack(format, packedRequest)

    def readInformation(self, request, data = None):
        ''' Read information from interface '''
        if data is not None:
            buffer = 16 - len(self.device)
            requestedInterface = self.device + '\0' * buffer
            requestedInterface += data
        else:
            requestedInterface = (self.device + '\0' * 32)
        try:
            result = fcntl.ioctl(self.sockfd.fileno(), request, requestedInterface)
        except IOError, (i, e):
            return i, e

        return (0, result[16:])

class DCOPIface(DCOPExObj):
    def __init__(self, wirelessStatusObject):
        ''' Constructor '''
        
        ''' Initialize DCOP ''' 
        DCOPExObj.__init__(self, "PyWirelessIface")
   
        self.wSO = wirelessStatusObject

        ''' DCOP functions '''
        self.addMethod("QString getInterfaceName()", self.getInterfaceName)
        self.addMethod("int getLinkStatus()", self.getLinkStatus)
        self.addMethod("int getNoiseStatus()", self.getNoiseStatus)
        self.addMethod("int getSignalStatus()", self.getSignalStatus)
        self.addMethod("QString getESSID()", self.getESSID)
        self.addMethod("QString getMode()", self.getMode)
        self.addMethod("QString returnReceived()", self.returnReceived)
        self.addMethod("QString returnTransferred()", self.returnTransferred)

    def getInterfaceName(self):
        return self.wSO.returnInterfaceName()

    def getLinkStatus(self):
        ''' Returns wireless link status % '''
        return self.wSO.returnLinkStatus()

    def getNoiseStatus(self):
        ''' Returns current noise level '''
        return self.wSO.returnNoiseStatus()

    def getSignalStatus(self):
        ''' Returns current signal level '''
        return self.wSO.returnSignalStatus()

    def getESSID(self):
        ''' Returns essid of interface '''
        return self.wSO.returnESSID()

    def getMode(self):
        ''' Returns operation mode of interface '''
        return self.wSO.returnMode()

    def returnReceived(self):
        ''' Returns received bytes '''
        return self.wSO.returnReceived()

    def returnTransferred(self):
        ''' Returns transferred bytes '''
        return self.wSO.returnTransferred()

class SystemTray(KSystemTray):
    def __init__(self, *args):
        apply(KSystemTray.__init__, (self,) + args)
# reference to WirelessStatus is also self.wirelessStatus=...

        ''' WirelessStatus instance '''
        self.wirelessStatus = WirelessStatus(self)

        ''' DCOP Interface ''' 
        self.DCOPInstance = DCOPIface(self.wirelessStatus)

        ''' Add /usr/share/PyWireless to KStandardDirs '''
        self.KStandardDirs =  KStandardDirs()
        self.KStandardDirs.addResourceDir("icon", "/usr/share/PyWireless/icons")
        ''' Tray icon Loader '''
        self.icons = KIconLoader("PyWireless", self.KStandardDirs)

        ''' Load icon on startup '''
        self.setPixmap(self.icons.loadIcon('pywireless', KIcon.Desktop, 22)) 

        ''' Timer event triggered every 5 second
            Until i found a way to use inotify or libfam '''
        self.time = QTimer(self)
        self.connect(self.time, SIGNAL('timeout()'), self.timeoutSlot)
        self.time.start(3000)

        self.connect(app, SIGNAL("shutDown()"), self.slotQuit)


# Create sub menu for interface selection
        self.interfaceSubMenu = KPopupMenu(self)
        self.contextMenu().insertItem("Select Interface", self.interfaceSubMenu)
        self.slotRefreshSubMenu()


        self.contextMenu().insertItem("Manage Connections", self.slotGuifi)

        self.contextMenu().insertItem("Continuous Monitor", self.slotMonitor)

# version 2:
        self.contextMenu().insertItem("Setup Default Connection", self.slotConfigurator)
        self.contextMenu().insertItem("Start/Stop Default Connection", self.slotStartStop)

        self.contextMenu().insertTitle("HELP & ABOUT")
        self.contextMenu().insertItem("Help", self.slotHelp)


        self.contextMenu().insertItem("About KWireless Tools Pro", self.slotAboutWirelessManager)
        self.contextMenu().insertItem("About QT", self.slotAboutQT)


        self.show()


    def slotRefreshSubMenu(self):
        # clear childs
        self.interfaceSubMenu.clear()
        # add new childs
        print "numberofIfaces2", self.wirelessStatus.numberofIfaces

        if self.wirelessStatus.numberofIfaces>0:

            for interface in self.wirelessStatus.interfaceList:
                ifaceId=self.interfaceSubMenu.insertItem(interface, self.slotInterfaceSelected)
                ifaceIndex=self.interfaceSubMenu.indexOf(ifaceId)
                if ifaceIndex==self.wirelessStatus.selectedIfaceIndex:
                    self.interfaceSubMenu.changeItem(ifaceId, QIconSet(self.wirelessStatus.image0), interface)
#        first=self.interfaceSubMenu.insertItem("submenu item name 1", self.slotMonitor)
#        firstindex=self.interfaceSubMenu.indexOf(first)

    def slotInterfaceSelected(self, id):

        self.wirelessStatus.device=self.interfaceSubMenu.text(id)
        print "Selected id       :", id
        print "Selected interface:", self.wirelessStatus.device
        self.interfaceSubMenu.changeItem(id, QIconSet(self.wirelessStatus.image0), str(self.wirelessStatus.device))
        self.wirelessStatus.selectedIfaceIndex=self.interfaceSubMenu.indexOf(id)


    def slotHelp(self):
        os.system("khelpcenter /usr/share/doc/kde/HTML/en/kwireless-tools-pro/index.html &")

    def slotGuifi(self):
        os.system("kdesu '/usr/share/PyWireless/guifi.pl %s' &" % (self.wirelessStatus.device))

    def slotMonitor(self):
        os.system("python /usr/share/PyWireless/monitorWindow.py %s &" % (self.wirelessStatus.device))

# version 2
    def slotConfigurator(self):
        os.system("kdesu 'python /usr/share/PyWireless/kwifiproperties.py %s' &" % (self.wirelessStatus.device))

    def slotStartStop(self):
        os.system("kdesu 'python /usr/share/PyWireless/ifupdown.py %s' &" % (self.wirelessStatus.device))

    def slotAboutWirelessManager(self):
        os.system("python /usr/share/PyWireless/aboutform.py &")

    def slotAboutQT(self):
        QMessageBox.aboutQt(self, "About Qt3")


    def slotQuit(self):
        self.deleteLater()
        app.quit()


    def timeoutSlot(self):
#        if self.wirelessStatus.device == "Nonem":
        self.slotRefreshSubMenu()
        self.wirelessStatus.device = self.wirelessStatus.findWirelessInterface()
        if self.wirelessStatus.device:
            interfaceName = self.wirelessStatus.returnInterfaceName()
            interfaceESSID = self.wirelessStatus.returnESSID()
            interfaceMode = self.wirelessStatus.returnMode()
            linkStatus = self.wirelessStatus.returnLinkStatus()
            noiseStatus = self.wirelessStatus.returnNoiseStatus()
            signalStatus = self.wirelessStatus.returnSignalStatus()
            #S/N ratio:
            SperNStatus = signalStatus - noiseStatus
            bitRate = self.wirelessStatus.returnBitrate()
            received = self.wirelessStatus.returnReceived()
            transferred = self.wirelessStatus.returnTransferred()
            status = self.wirelessStatus.returnInterfaceStatus()

        ''' Tray icon name '''
        if self.wirelessStatus.device and int(status):

            if linkStatus < 5:
                index = 0
            elif linkStatus < 10:
                index = 1
            elif linkStatus < 20:
                index = 2
            elif linkStatus < 40:
                index = 3
            elif linkStatus < 70:
                index = 4
            else:
                index = 5

#            index = int(linkStatus) / 20
            iconName = 'pywireless_' + str(index)

            ''' Tooltip '''
            toolTip = _('''<center><img align="center" src="/usr/share/PyWireless/icons/%s.png"></center>
            <center>
            <table border="0" bgcolor="#000000" cellspacing="1" cellpadding="1">
            <tr>
                <td colspan="2" bgcolor="#04CC1A"><center><b>Monitoring:</b> [ %s ]</b></center></td>
            <tr>
                <td bgcolor="#CCCCCC"><b>ESSID:</b></td>
                <td bgcolor="#CCCCCC"><center>%s</center></td>
            </tr>
            <tr>
                <td bgcolor="#EEEEEE"><b>Link Quality:</b></td>
                    <td bgcolor="#EEEEEE"><center>%d</center></td>
            </tr>
            <tr>
                <td bgcolor="#CCCCCC"><b>S/N Ratio:</b></td>
                <td bgcolor="#CCCCCC"><center>%d dBm</center></td>
            </tr>
            <tr>
                <td bgcolor="#EEEEEE"><b>Signal Level:</b></td>
                <td bgcolor="#EEEEEE"><center>%d dBm</center></td>
            </tr>
            <tr>
                <td bgcolor="#CCCCCC"><b>Bitrate:</b></td>
                <td bgcolor="#CCCCCC"><center>%s</center></td>
            </tr>
            <tr>
               <td bgcolor="#EEEEEE"><b>Mode:</b></td>
                <td bgcolor="#EEEEEE"><center>%s</center></td>
            </tr>
            <tr>
                <td bgcolor="#CCCCCC"><b>Received:</b></td>
                <td bgcolor="#CCCCCC"><center>%s</center></td>
            </tr>
            <tr>
                <td bgcolor="#EEEEEE"><b>Transferred:</b></td>
                <td bgcolor="#EEEEEE"><center>%s</center></td>
            </tr>
            </table>
            </center>
            ''') % (iconName, interfaceName, interfaceESSID, linkStatus, SperNStatus, signalStatus, bitRate, interfaceMode, received, transferred)
        elif self.wirelessStatus.device:
            iconName = 'pywireless'
            toolTip = _('''<center><img align="center" src="/usr/share/PyWireless/icons/%s.png"></center>
            <center>
            <table border="0" bgcolor="#000000" cellspacing="1" cellpadding="1">
            <tr>
                <td colspan="2" bgcolor="#DD0500"><center><b>Interface '%s' <br>is powered off</b></center></td>
            <tr>
            </table>
            </center>''') % (iconName, interfaceName)

        else:
            iconName = 'pywireless_none'
            toolTip = _('''<center><img align="center" src="/usr/share/PyWireless/icons/%s.png"></center>
            <center>
            <table border="0" bgcolor="#000000" cellspacing="1" cellpadding="1">
            <tr>
                <td colspan="2" bgcolor="#DD0500"><center> <b>Wireless interface<br>not found</b></center></td>
            <tr>
            </table>
            </center>''') % (iconName)


##                <td colspan="2" bgcolor="#DD0500"><center>[ %s ] <b>is powered off</b></center></td>
##            </center>''') % (iconName, interfaceName)

        QToolTip.add(self, toolTip)
        self.setPixmap(self.icons.loadIcon(iconName, KIcon.Desktop, 22))

if __name__ == '__main__':
    appName = 'PyWireless'
    programName = 'PyWireless'
    description = 'A Basic Wireless Connection Monitor'
    license = KAboutData.License_GPL
    version = '3.0'
    NameVersion = 'KWireless Tools Pro 1.2'
    copyright = '(C) 2005 S.Çağlar Onur <caglar@uludag.org.tr>'

    sys.argv.extend(['--icon', '/usr/share/PyWireless/icons/pywireless_5.png', '--caption', NameVersion])


    aboutData = KAboutData(appName, programName, version, description, license, copyright)

    aboutData.addAuthor('S.Çağlar Onur', 'Maintainer', 'caglar@uludag.org.tr')
    aboutData.addAuthor('Onur Küçük', 'Contributor [Rx/Tx bytes part]', 'onur@uludag.org.tr')
    aboutData.addAuthor('Serdar Soytetir', 'Contributor [New PyWireless Icons & UI Improvements]', 'sendirom@gmail.com')
    aboutData.addAuthor('Furkan Duman', 'Contributor [Bug fix]', 'coderlord@yahoo.com')

    KCmdLineArgs.init(sys.argv, aboutData)
    KCmdLineArgs.addCmdLineOptions([('+files', 'File to open')])

    ''' Use KUniqueApplication and initialize'''
    gettext.install(appName)
    app = KUniqueApplication(True, True, True)
    trayWindow = SystemTray(None, appName)
    app.setMainWidget(trayWindow)

    ''' Enter main loop '''
    app.exec_loop()
