##/usr/bin/python
# -*- coding: utf-8 -*-
#
# Copyright (C) Big-Cat Software Association, 2007.
#
# GILDE project.
# (Graphical Interfaces to Learn Debian Easily)
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version. Please read the COPYING file.
#

import sys

from qt import *


from time import sleep

from ifupdown_ui import ifupdown_Ui
from myprocess import *


class ifupdownMain(ifupdown_Ui):

    def __init__(self):
        ifupdown_Ui.__init__(self)


# Iface combobox

        self.device=sys.argv[1]
        self.comboBoxIface.insertItem(self.device)

# Active interface name

        self.class_path = '/sys/class/net'
        self.findWirelessInterface()

# List of all interface, append to combobox list
    def findWirelessInterface(self):

        ''' Finds wireless interface '''
        fileName = 'wireless'
        for interface in os.listdir(self.class_path):
            if os.path.exists(os.path.join(self.class_path, interface, fileName)) and (not interface==self.device):

                self.comboBoxIface.insertItem(interface)


    def ifUpSlot(self):

        self.currentprocess = MyProcess(self.textEdit1, "/", ("ifup", str(self.comboBoxIface.currentText())), "", "normal")

        self.currentprocess.thread.process.connect(self.currentprocess.thread.process, SIGNAL("processExited()"), self.processExited)

    def ifDownSlot(self):

        self.currentprocess = MyProcess(self.textEdit1, "/", ("ifdown", str(self.comboBoxIface.currentText())), "", "normal")

        self.currentprocess.thread.process.connect(self.currentprocess.thread.process, SIGNAL("processExited()"), self.processExited)


    def cancelProcess(self):
        self.currentprocess.cancelProcess()


    def processExited(self):
        print "Ifup/ifdown exited."
        try:
            self.cancelProcess()
        except:
            pass

        self.currentprocess = MyProcess(self.textEdit1, "/", ("sleep", "5"), "", "normal")
        self.currentprocess.thread.process.connect(self.currentprocess.thread.process, SIGNAL("processExited()"), self.quitSlot)

    def quitSlot(self):
        try:
            self.cancelProcess()
        except:
            pass
        self.close()



def main(args):
    qapptitle=['Wireless Manager Pro 1.1']
    print args
    app=QApplication(qapptitle)
    win=ifupdownMain()
#    win.setMinimumSize(QSize(600,600))
    win.show()
    app.connect(app, SIGNAL("lastWindowClosed()"), app , SLOT("quit()"))
    app.exec_loop()

if __name__=="__main__":
    main(sys.argv)
