##/usr/bin/python
# -*- coding: utf-8 -*-
#
# Copyright (C) Big-Cat Software Association, 2007.
#
# GILDE project.
# (Graphical Interfaces to Learn Debian Easily)
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version. Please read the COPYING file.
#

#import tempfile, shutil
import os, sys, re, string

from qt import *
from time import sleep


from kwifipropertiesbase import KWiFiPropertiesBase
from myprocess import *


class KWiFiProperties(KWiFiPropertiesBase):

    modes = ['Auto', 'Ad-Hoc', 'Managed', 'Master', 'Repeat', 'Second', 'Monitor']


    def __init__(self):
        KWiFiPropertiesBase.__init__(self)

        self.user_guifirc=os.path.expanduser("~/.kwirelesstoolspro/.guifirc")
        self.user_kwifirc=os.path.expanduser("~/.kwirelesstoolspro/.kwifirc")
        print self.user_kwifirc

        if not os.path.exists(self.user_guifirc):
            QMessageBox.information(None, "Missing Configuration File", "Please use the 'Manage Connections'\nin order to create a basic configuration file!\n(Click on the 'Up', 'Scan' and 'Save' buttons!)", QMessageBox.Ok)
            sys.exit(1)

        if not os.path.exists("/etc/network/interfaces"):
            QMessageBox.information(None, "Missing Configuration File", "Debian type Wireless Tools configuration file not found.\nPlease check your installation!\nYou cannot use this module on your system.", QMessageBox.Ok)
            sys.exit(1)

# vrs 1.1:
# Iface combobox

        self.device=sys.argv[1]
        self.comboBoxIface.insertItem(self.device)

# Active interface name

        self.class_path = '/sys/class/net'
        self.findWirelessInterface()

# MOVED FROM NEXT DEF END
# Filling out lineedit fileds tab pages Network and Security
        if os.path.exists(self.user_kwifirc):
            self.readkwifirc()
        else:
            self.essid=""

        self.readguifirc()

        self.essidChangedSlot()

# List of all interface, append to combobox list
    def findWirelessInterface(self):

        ''' Finds wireless interface '''
        fileName = 'wireless'
        for interface in os.listdir(self.class_path):
            if os.path.exists(os.path.join(self.class_path, interface, fileName)) and (not interface==self.device):

                self.comboBoxIface.insertItem(interface)

# end vrs 1.1


#str(self.comboBoxEssid.currentText())


    def dhcptoggledSlot(self):
        if self.checkBoxDHCP.isChecked():
            self.groupBoxIpconfig.setChecked(0)
        else:
            self.groupBoxIpconfig.setChecked(1)


    def statictoggledSlot(self):
        if self.groupBoxIpconfig.isChecked():
            self.checkBoxDHCP.setChecked(0)
        else:
            self.checkBoxDHCP.setChecked(1)

    def helpSlot(self):
        os.system("khelpcenter /usr/share/doc/kde/HTML/en/kwireless-tools-pro/index.html &")

#    def cancelProcess(self):
#        self.currentprocess.cancelProcess()


#    def quitSlot(self):
#        self.close()


    def readkwifirc(self):

        rcfile=open(self.user_kwifirc, "r")
        kwifirc_raws=rcfile.readlines()
        rcfile.close()

  
        for line in kwifirc_raws:
# Default essid
            if line[0:10]=="essid:    ":
                self.essid=line[10:-1]
                self.comboBoxEssid.insertItem(self.essid)
# Checkboxes
            if line[0:10]=="forcemac: " and line[10:-1]=="TRUE":
                self.checkBoxMAC.setChecked(1)
            if line[0:10]=="auto:     " and line[10:-1]=="TRUE":
                self.checkBoxAutoconnect.setChecked(1)
            if line[0:10]=="dhcp:     " and line[10:-1]=="TRUE":
                self.checkBoxDHCP.setChecked(1)
            if line[0:10]=="wpa:      " and line[10:-1]=="TRUE":
                self.groupBoxWPA.setChecked(1)
            if line[0:10]=="preup:    " and line[10:-1]=="TRUE":
                self.groupBoxPreUp.setChecked(1)
            if line[0:10]=="up:       " and line[10:-1]=="TRUE":
                self.groupBoxUp.setChecked(1)
            if line[0:10]=="predown:  " and line[10:-1]=="TRUE":
                self.groupBoxPreDown.setChecked(1)
            if line[0:10]=="down:     " and line[10:-1]=="TRUE":
                self.groupBoxDown.setChecked(1)
            if line[0:10]=="spoofmac: " and line[10:-1]=="TRUE":
                self.groupBoxPreUp_2.setChecked(1)
# Comboboxes

            if line[0:10]=="channel:  ":
                self.comboBoxchannel.setCurrentText(line[10:-1])
            if line[0:10]=="mode:     ":
                self.comboBoxmode.setCurrentText(line[10:-1])
            # Encoding
            if line[0:10]=="driver:   ":
                self.comboBoxWPADriver.setCurrentText(line[10:-1])
# FENT !!! kezdoerteke van !!!
            if line[0:10]=="protocol: ":
                self.comboBoxProtocol.setCurrentText(line[10:-1])
            if line[0:10]=="mgmproto: ":
                self.comboBoxWpa_key_mgmt.setCurrentText(line[10:-1])
            if line[0:10]=="grcipher: ":
                self.comboBoxGcipher.setCurrentText(line[10:-1])
            if line[0:10]=="pcipher:  ":
                self.comboBoxPcipher.setCurrentText(line[10:-1])
            if line[0:10]=="authalg:  ":
                self.comboBoxAuthalg.setCurrentText(line[10:-1])
            # Page Advanced:
            if line[0:10]=="power:    ":
                self.comboBoxpower.setCurrentText(line[10:-1])
            if line[0:10]=="txpower:  ":
                self.comboBoxtxpower.setCurrentText(line[10:-1])
            if line[0:10]=="rate:     ":
                self.comboBoxrate.setCurrentText(line[10:-1])
            if line[0:10]=="freq:     ":
                self.comboBoxfragfreq.setCurrentText(line[10:-1])
            if line[0:10]=="sens:     ":
                self.comboBoxsens.setCurrentText(line[10:-1])
            if line[0:10]=="retry:    ":
                self.comboBoxretry.setCurrentText(line[10:-1])
            if line[0:10]=="rts:      ":
                self.comboBoxrts.setCurrentText(line[10:-1])
            if line[0:10]=="frag:     ":
                self.comboBoxfrag.setCurrentText(line[10:-1])

# Textlines
            if line[0:10]=="wpakey:   ":
                self.lineEditPassphrase.setText(line[10:-1])
            if line[0:10]=="eapid:    ":
                self.lineEditEAPid.setText(line[10:-1])
            if line[0:10]=="eappass:  ":
                self.lineEditEAPpass.setText(line[10:-1])
            if line[0:10]=="preup1:   ":
                self.lineEditPreup1.setText(line[10:-1])
            if line[0:10]=="preup2:   ":
                self.lineEditPreup2.setText(line[10:-1])
            if line[0:10]=="up1:      ":
                self.lineEditUp1.setText(line[10:-1])
            if line[0:10]=="up2:      ":
                self.lineEditUp2.setText(line[10:-1])
            if line[0:10]=="predown1: ":
                self.lineEditPredown1.setText(line[10:-1])
            if line[0:10]=="predown2: ":
                self.lineEditPredown2.setText(line[10:-1])
            if line[0:10]=="down1:    ":
                self.lineEditDown1.setText(line[10:-1])
            if line[0:10]=="down2:    ":
                self.lineEditDown2.setText(line[10:-1])
            if line[0:10]=="spoofadd: ":
                self.lineEditlineEditSpoofMAC.setText(line[10:-1])



    def readguifirc(self):

        rcfile=open(self.user_guifirc, "r")
        self.rc_raws=rcfile.readlines()
        rcfile.close()


        for line in self.rc_raws:
            if line[0:6]=="essid=" and (not self.essid==line[6:-1]):
                self.comboBoxEssid.insertItem(line[6:-1])




    def essidChangedSlot(self):

        self.clearLines()

        print "Essid changed, current index:"
        currentindex=self.comboBoxEssid.currentItem()

        match_flag=0
        mac_counter=-1

        for line in self.rc_raws:
#            if mac_counter==currentindex:
            print "---------------"

            if line[0:1]=="[":
                mac_counter=mac_counter+1

            if line[0:1]=="[" and mac_counter==currentindex:
                print "line match"
                self.lineEditMAC.setText(line[1:-2])
                match_flag=1

            elif mac_counter>currentindex:
                print "break: mac_counter>currentindex"
                print mac_counter
                print currentindex
                break

            elif match_flag==1:
                print "match flag"
                print line
                if line[0:3]=="ip=":
                    self.lineEditIP.setText(line[3:-1])

                if line[0:5]=="mask=":
                    self.lineEditNetmask.setText(line[5:-1])

                if line[0:3]=="gw=":
                    self.lineEditGateway.setText(line[3:-1])

                if line[0:4]=="dns=":
                    self.lineEditDNS.setText(line[4:-1])

                if line[0:5]=="wep1=":
                    self.lineEditWEP1.setText(line[5:-1])

                if line[0:5]=="wep2=":
                    self.lineEditWEP2.setText(line[5:-1])

                if line[0:5]=="wep3=":
                    self.lineEditWEP3.setText(line[5:-1])

                if line[0:5]=="wep4=":
                    self.lineEditWEP4.setText(line[5:-1])

# Setup checks

# Ell!!!: guifirc

#                if line[0:-1]=="auto=1":
#                    self.checkBoxAutoconnect.setChecked(1)

                if self.lineEditIP.text()=="":
                    self.checkBoxDHCP.setChecked(1)
                    self.groupBoxIpconfig.setChecked(0)
                else:
                    self.groupBoxIpconfig.setChecked(1)
                    self.checkBoxDHCP.setChecked(0)

                if self.lineEditWEP1.text()=="" and self.lineEditWEP2.text()=="" and self.lineEditWEP3.text()=="" and self.lineEditWEP4.text()=="" :
                    self.groupBoxWEP.setChecked(0)
                else:
                    self.groupBoxWEP.setChecked(1)

            else:
                pass



    def saveSlot(self):
        self.writekwifirc()
        ifaceName=self.comboBoxIface.currentText()
        r = QMessageBox.question(self, "System file overwrite",
            "All of the wireless options will be overwritten\nfor interface '%s' if you proceed!\nA backup file will be created.\n\n Are you sure?\n" % ifaceName,
            "&Yes", "&No")
        if r == 1:
#            pass
            return
        if r == 0:
            print "Yes choosed"
            self.rewriteInterfacesFile()
            return



    def writekwifirc(self):
# Reverse method
        new_kwifirc_raws=[]

# Empty boxes problem?!!!!!!!!!!!!!!!!!!!!!
# Default essid

        new_kwifirc_raws.append("essid:    "+self.comboBoxEssid.currentText()+"\n")
# Checkboxes
        if self.checkBoxMAC.isChecked():
            new_kwifirc_raws.append("forcemac: TRUE\n")
        else:
            new_kwifirc_raws.append("forcemac: FALSE\n")
        if self.checkBoxAutoconnect.isChecked():
            new_kwifirc_raws.append("auto:     TRUE\n")
        else:
            new_kwifirc_raws.append("auto:     FALSE\n")
        if self.checkBoxDHCP.isChecked():
            new_kwifirc_raws.append("dhcp:     TRUE\n")
        else:
            new_kwifirc_raws.append("dhcp:     FALSE\n")
        if self.groupBoxWPA.isChecked():
            new_kwifirc_raws.append("wpa:      TRUE\n")
        else:
            new_kwifirc_raws.append("wpa:      FALSE\n")
        if self.groupBoxPreUp.isChecked():
            new_kwifirc_raws.append("preup:    TRUE\n")
        else:
            new_kwifirc_raws.append("preup:    FALSE\n")
        if self.groupBoxUp.isChecked():
            new_kwifirc_raws.append("up:       TRUE\n")
        else:
            new_kwifirc_raws.append("up:       FALSE\n")
        if self.groupBoxPreDown.isChecked():
            new_kwifirc_raws.append("predown:  TRUE\n")
        else:
            new_kwifirc_raws.append("predown:  FALSE\n")
        if self.groupBoxDown.isChecked():
            new_kwifirc_raws.append("down:     TRUE\n")
        else:
            new_kwifirc_raws.append("down:     FALSE\n")
        if self.groupBoxPreUp_2.isChecked():
            new_kwifirc_raws.append("spoofmac: TRUE\n")
        else:
            new_kwifirc_raws.append("spoofmac: FALSE\n")

# Comboboxes
        new_kwifirc_raws.append("channel:  "+self.comboBoxchannel.currentText()+"\n")
        new_kwifirc_raws.append("mode:     "+self.comboBoxmode.currentText()+"\n")
        # Encoding:
        new_kwifirc_raws.append("driver:   "+self.comboBoxWPADriver.currentText()+"\n")
# FENT !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! kezdoerteke van!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        new_kwifirc_raws.append("protocol: "+self.comboBoxProtocol.currentText()+"\n")
        new_kwifirc_raws.append("mgmproto: "+self.comboBoxWpa_key_mgmt.currentText()+"\n")
        new_kwifirc_raws.append("grcipher: "+self.comboBoxGcipher.currentText()+"\n")
        new_kwifirc_raws.append("pcipher:  "+self.comboBoxPcipher.currentText()+"\n")
        new_kwifirc_raws.append("authalg:  "+self.comboBoxAuthalg.currentText()+"\n")
        # Page Advanced:
        new_kwifirc_raws.append("power:    "+self.comboBoxpower.currentText()+"\n")
        new_kwifirc_raws.append("txpower:  "+self.comboBoxtxpower.currentText()+"\n")
        new_kwifirc_raws.append("rate:     "+self.comboBoxrate.currentText()+"\n")
        new_kwifirc_raws.append("freq:     "+self.comboBoxfragfreq.currentText()+"\n")
        new_kwifirc_raws.append("sens:     "+self.comboBoxsens.currentText()+"\n")
        new_kwifirc_raws.append("retry:    "+self.comboBoxretry.currentText()+"\n")
        new_kwifirc_raws.append("rts:      "+self.comboBoxrts.currentText()+"\n")
        new_kwifirc_raws.append("frag:     "+self.comboBoxfrag.currentText()+"\n")
# Textlines
        new_kwifirc_raws.append("wpakey:   "+self.lineEditPassphrase.text()+"\n")
        new_kwifirc_raws.append("eapid:    "+self.lineEditEAPid.text()+"\n")
        new_kwifirc_raws.append("eappass:  "+self.lineEditEAPpass.text()+"\n")
        new_kwifirc_raws.append("preup1:   "+self.lineEditPreup1.text()+"\n")
        new_kwifirc_raws.append("preup2:   "+self.lineEditPreup2.text()+"\n")
        new_kwifirc_raws.append("up1:      "+self.lineEditUp1.text()+"\n")
        new_kwifirc_raws.append("up2:      "+self.lineEditUp2.text()+"\n")
        new_kwifirc_raws.append("predown1: "+self.lineEditPredown1.text()+"\n")
        new_kwifirc_raws.append("predown2: "+self.lineEditPredown2.text()+"\n")
        new_kwifirc_raws.append("down1:    "+self.lineEditDown1.text()+"\n")
        new_kwifirc_raws.append("down2:    "+self.lineEditDown2.text()+"\n")
        new_kwifirc_raws.append("spoofadd: "+self.lineEditlineEditSpoofMAC.text()+"\n")

        # Delete file before?

#    print new_interfaces_raws to interfaces file
        new_rcfile=open(self.user_kwifirc, "w")
        new_rcfile.writelines(new_kwifirc_raws)
        new_rcfile.close()




    def rewriteInterfacesFile(self):
        if self.groupBoxWPA.isChecked():
            self.rewriteWPAInterfaces()
        else:
            self.rewriteInterfaces()



    def rewriteInterfaces(self):
        ifaceName=str(self.comboBoxIface.currentText())

        os.chdir("/etc/network")

        try:
            os.remove("interfaces.old")
        except os.error:
            pass

        os.rename("interfaces", "interfaces.old")

        interfacesfile=open("interfaces.old", "r")
        interfaces_raws=interfacesfile.readlines()
        interfacesfile.close()

        new_interfaces_raws=[]

        in_flag=0


        for line in interfaces_raws:

            concerntoIface=line.count(ifaceName)

            ifaceLine=line.count("iface")

            if concerntoIface>0 and ifaceLine>0:
                in_flag=1

                print "Concerns to iface and iface raw:"
                print line
                print "deleting raw"

            elif ifaceLine>0:
                in_flag=0
            if in_flag==0 and concerntoIface==0:
                new_interfaces_raws.append(line)

# Append iface properties to file:

# Info:
        new_interfaces_raws.append("#                   - ["+ifaceName+"] -\n" )
        new_interfaces_raws.append("# Created by KWireless Tools Pro for interface ["+ifaceName+"]\n" )

# If auto
        if self.checkBoxAutoconnect.isChecked():
            new_interfaces_raws.append("auto "+ifaceName+"\n")

# If static
        if self.groupBoxIpconfig.isChecked():
            new_interfaces_raws.append("iface "+ifaceName+" inet static\n")
        else:
            new_interfaces_raws.append("iface "+ifaceName+" inet dhcp\n")

# Pre-up commands maybe here is correct
#        if self.groupBoxPreUp.isChecked():
#            if not self.lineEditPreup1.text()=="":
#                new_interfaces_raws.append("pre-up "+self.lineEditPreup1.text()+"\n")
#            if not self.lineEditPreup2.text()=="":
#                new_interfaces_raws.append("pre-up "+self.lineEditPreup2.text()+"\n")

# If spoof
        if self.groupBoxPreUp_2.isChecked():
            new_interfaces_raws.append("pre-up ifconfig "+ifaceName+" down hw ether "+self.lineEditlineEditSpoofMAC.text()+"\n")

# Up and ESSID:
        new_interfaces_raws.append("pre-up ifconfig "+ifaceName+" up\n")
        new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" essid "+self.comboBoxEssid.currentText()+"\n")
        if self.checkBoxMAC.isChecked():
            new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" ap "+self.lineEditMAC.text()+"\n")


        if not self.comboBoxchannel.currentText()=="":
            new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" channel "+self.comboBoxchannel.currentText()+"\n")
        if not self.comboBoxmode.currentText()=="":
            new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" mode "+self.comboBoxmode.currentText()+"\n")
        # Page Advanced:
        if not self.comboBoxpower.currentText()=="":
            new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" power "+self.comboBoxpower.currentText()+"\n")
        if not self.comboBoxtxpower.currentText()=="":
            new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" txpower "+self.comboBoxtxpower.currentText()+"\n")
        if not self.comboBoxrate.currentText()=="":
            new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" rate "+self.comboBoxrate.currentText()+"\n")
        if not self.comboBoxfragfreq.currentText()=="":
            new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" freq "+self.comboBoxfragfreq.currentText()+"\n")
        if not self.comboBoxsens.currentText()=="":
            new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" sens "+self.comboBoxsens.currentText()+"\n")
        if not self.comboBoxretry.currentText()=="":
            new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" retry "+self.comboBoxretry.currentText()+"\n")
        if not self.comboBoxrts.currentText()=="":
            new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" rts "+self.comboBoxrts.currentText()+"\n")
        if not self.comboBoxfrag.currentText()=="":
            new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" frag "+self.comboBoxfrag.currentText()+"\n")

# WEP keys:
        if self.groupBoxWEP.isChecked():
            if not self.lineEditWEP1.text()=="":
                new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" key [1] "+self.lineEditWEP1.text()+"\n")
                if self.radioButtonWEP1.isChecked():
                    new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" key [1]\n")

            if not self.lineEditWEP2.text()=="":
                new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" key [2] "+self.lineEditWEP2.text()+"\n")
                if self.radioButtonWEP2.isChecked():
                    new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" key [2]\n")

            if not self.lineEditWEP3.text()=="":
                new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" key [3] "+self.lineEditWEP3.text()+"\n")
                if self.radioButtonWEP3.isChecked():
                    new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" key [3]\n")

            if not self.lineEditWEP4.text()=="":
                new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" key [4] "+self.lineEditWEP4.text()+"\n")
                if self.radioButtonWEP4.isChecked():
                    new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" key [4]\n")

# Pre-up commands
        if self.groupBoxPreUp.isChecked():
            if not self.lineEditPreup1.text()=="":
                new_interfaces_raws.append("pre-up "+self.lineEditPreup1.text()+"\n")
            if not self.lineEditPreup2.text()=="":
                new_interfaces_raws.append("pre-up "+self.lineEditPreup2.text()+"\n")
# Up commands
        if self.groupBoxUp.isChecked():
            if not self.lineEditUp1.text()=="":
                new_interfaces_raws.append("up "+self.lineEditUp1.text()+"\n")
            if not self.lineEditUp2.text()=="":
                new_interfaces_raws.append("up "+self.lineEditUp2.text()+"\n")
# Pre-down commands
        if self.groupBoxPreDown.isChecked():
            if not self.lineEditPredown1.text()=="":
                new_interfaces_raws.append("down "+self.lineEditPredown1.text()+"\n")
            if not self.lineEditPredown2.text()=="":
                new_interfaces_raws.append("down "+self.lineEditPredown2.text()+"\n")
# Down commands
        if self.groupBoxDown.isChecked():
            if not self.lineEditDown1.text()=="":
                new_interfaces_raws.append("post-down "+self.lineEditDown1.text()+"\n")
            if not self.lineEditDown2.text()=="":
                new_interfaces_raws.append("post-down "+self.lineEditDown2.text()+"\n")

# If static, addresses
        if self.groupBoxIpconfig.isChecked():
            new_interfaces_raws.append("    address "+self.lineEditIP.text()+"\n")
            new_interfaces_raws.append("    netmask "+self.lineEditNetmask.text()+"\n")
            new_interfaces_raws.append("    gateway "+self.lineEditGateway.text()+"\n")
            new_interfaces_raws.append("    dns-nameservers "+self.lineEditDNS.text()+"\n")

#    print new_interfaces_raws to interfaces file
        new_interfacesfile=open("interfaces", "w")
        new_interfacesfile.writelines(new_interfaces_raws)
        new_interfacesfile.close()


    def rewriteWPAInterfaces(self):
        ifaceName=str(self.comboBoxIface.currentText())

        os.chdir("/etc/network")

        try:
            os.remove("interfaces.old")
        except os.error:
            pass

        os.rename("interfaces", "interfaces.old")

        interfacesfile=open("interfaces.old", "r")
        interfaces_raws=interfacesfile.readlines()
        interfacesfile.close()

        new_interfaces_raws=[]

        in_flag=0


        for line in interfaces_raws:

            concerntoIface=line.count(ifaceName)

            ifaceLine=line.count("iface")

            if concerntoIface>0 and ifaceLine>0:
                in_flag=1

                print "Concerns to iface and iface raw:"
                print line
                print "deleting raw"

            elif ifaceLine>0:
                in_flag=0
            if in_flag==0 and concerntoIface==0:
                new_interfaces_raws.append(line)

# Append iface properties to file:

# Info:
        new_interfaces_raws.append("#                   - ["+ifaceName+"] -\n" )
        new_interfaces_raws.append("# Created by KWireless Tools Pro for interface ["+ifaceName+"]\n" )

# If auto
        if self.checkBoxAutoconnect.isChecked():
            new_interfaces_raws.append("auto "+ifaceName+"\n")

# If static
        if self.groupBoxIpconfig.isChecked():
            new_interfaces_raws.append("iface "+ifaceName+" inet static\n")
        else:
            new_interfaces_raws.append("iface "+ifaceName+" inet dhcp\n")

# Pre-up commands maybe here are incorrect!!!

# If spoof
        if self.groupBoxPreUp_2.isChecked():
            new_interfaces_raws.append("pre-up ifconfig "+ifaceName+" down hw ether "+self.lineEditlineEditSpoofMAC.text()+"\n")

        if not self.comboBoxchannel.currentText()=="":
            new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" channel "+self.comboBoxchannel.currentText()+"\n")
        if not self.comboBoxmode.currentText()=="":
            new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" mode "+self.comboBoxmode.currentText()+"\n")
        # Page Advanced:
        if not self.comboBoxpower.currentText()=="":
            new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" power "+self.comboBoxpower.currentText()+"\n")
        if not self.comboBoxtxpower.currentText()=="":
            new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" txpower "+self.comboBoxtxpower.currentText()+"\n")
        if not self.comboBoxrate.currentText()=="":
            new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" rate "+self.comboBoxrate.currentText()+"\n")
        if not self.comboBoxfragfreq.currentText()=="":
            new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" freq "+self.comboBoxfragfreq.currentText()+"\n")
        if not self.comboBoxsens.currentText()=="":
            new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" sens "+self.comboBoxsens.currentText()+"\n")
        if not self.comboBoxretry.currentText()=="":
            new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" retry "+self.comboBoxretry.currentText()+"\n")
        if not self.comboBoxrts.currentText()=="":
            new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" rts "+self.comboBoxrts.currentText()+"\n")
        if not self.comboBoxfrag.currentText()=="":
            new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" frag "+self.comboBoxfrag.currentText()+"\n")



# Pre-up commands
        if self.groupBoxPreUp.isChecked():
            if not self.lineEditPreup1.text()=="":
                new_interfaces_raws.append("pre-up "+self.lineEditPreup1.text()+"\n")
            if not self.lineEditPreup2.text()=="":
                new_interfaces_raws.append("pre-up "+self.lineEditPreup2.text()+"\n")
# Up commands
        if self.groupBoxUp.isChecked():
            if not self.lineEditUp1.text()=="":
                new_interfaces_raws.append("up "+self.lineEditUp1.text()+"\n")
            if not self.lineEditUp2.text()=="":
                new_interfaces_raws.append("up "+self.lineEditUp2.text()+"\n")
# Pre-down commands
        if self.groupBoxPreDown.isChecked():
            if not self.lineEditPredown1.text()=="":
                new_interfaces_raws.append("down "+self.lineEditPredown1.text()+"\n")
            if not self.lineEditPredown2.text()=="":
                new_interfaces_raws.append("down "+self.lineEditPredown2.text()+"\n")
# Down commands
        if self.groupBoxDown.isChecked():
            if not self.lineEditDown1.text()=="":
                new_interfaces_raws.append("post-down "+self.lineEditDown1.text()+"\n")
            if not self.lineEditDown2.text()=="":
                new_interfaces_raws.append("post-down "+self.lineEditDown2.text()+"\n")


# WPA specific part begins

# Up and ESSID:
        if not self.comboBoxWPADriver.currentText()=="":
            new_interfaces_raws.append("    wpa-driver "+self.comboBoxWPADriver.currentText()+"\n")

        new_interfaces_raws.append("    wpa-ssid "+self.comboBoxEssid.currentText()+"\n")

        if self.checkBoxMAC.isChecked():
            new_interfaces_raws.append("    wpa-bssid "+self.lineEditMAC.text()+"\n")

# WPA keys:
        if not self.comboBoxProtocol.currentText()=="":
            new_interfaces_raws.append("    wpa-proto "+self.comboBoxProtocol.currentText()+"\n")

        if not self.lineEditPassphrase.text()=="":
            new_interfaces_raws.append("    wpa-psk "+self.lineEditPassphrase.text()+"\n")

        if not self.lineEditEAPid.text()=="":
            new_interfaces_raws.append("    wpa-identity "+self.lineEditEAPid.text()+"\n")

        if not self.lineEditEAPpass.text()=="":
            new_interfaces_raws.append("    wpa-password "+self.lineEditEAPpass.text()+"\n")

        if not self.comboBoxWpa_key_mgmt.currentText()=="":
            new_interfaces_raws.append("    wpa-key-mgmt "+self.comboBoxWpa_key_mgmt.currentText()+"\n")

        if not self.comboBoxGcipher.currentText()=="":
            new_interfaces_raws.append("    wpa-group "+self.comboBoxGcipher.currentText()+"\n")

        if not self.comboBoxPcipher.currentText()=="":
            new_interfaces_raws.append("    wpa-pairwise "+self.comboBoxPcipher.currentText()+"\n")

        if not self.comboBoxAuthalg.currentText()=="":
            new_interfaces_raws.append("    wpa-auth-alg "+self.comboBoxAuthalg.currentText()+"\n")


# If static, addresses
        if self.groupBoxIpconfig.isChecked():
            new_interfaces_raws.append("    address "+self.lineEditIP.text()+"\n")
            new_interfaces_raws.append("    netmask "+self.lineEditNetmask.text()+"\n")
            new_interfaces_raws.append("    gateway "+self.lineEditGateway.text()+"\n")
            new_interfaces_raws.append("    dns-nameservers "+self.lineEditDNS.text()+"\n")


#    print new_interfaces_raws to interfaces file
        new_interfacesfile=open("interfaces", "w")
        new_interfacesfile.writelines(new_interfaces_raws)
        new_interfacesfile.close()




    def clearLines(self):

        self.lineEditIP.clear()
        self.lineEditNetmask.clear()
        self.lineEditGateway.clear()
        self.lineEditDNS.clear()
        self.lineEditWEP1.clear()
        self.lineEditWEP2.clear()
        self.lineEditWEP3.clear()
        self.lineEditWEP4.clear()







def main(args):
    qapptitle=['Wireless Manager Pro 1.0']
    print args

    app=QApplication(qapptitle)
    win=KWiFiProperties()
#    win.setMinimumSize(QSize(600,600))
    win.show()
    app.connect(app, SIGNAL("lastWindowClosed()"), app , SLOT("quit()"))
    app.exec_loop()





if __name__=="__main__":
    main(sys.argv)
