##/usr/bin/python
# -*- coding: utf-8 -*-
#
# Copyright (C) Big-Cat Software Association, 2007.
#
# GILDE project. 
# (Graphical Interfaces to Learn Debian Easily)
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version. Please read the COPYING file.
#

import sys, re
from qt import *

from monitor import *


class MonitorWindow(QMainWindow):



    def __init__(self, *args):
        apply(QMainWindow.__init__, (self, None, "mzujabb") + args)

        self.setName("main window")
        self.mainWidget=QWidget(self)

        self.setCentralWidget(self.mainWidget)
        self.mainLayout=QVBoxLayout(self.mainWidget, 0, 0, "main")


        self.widgetDialog=WirelessPlot(self.mainWidget)
        self.widgetDialog.setFixedSize(700,450)
        self.widgetDialog.setTitle("Continuous read")
        self.widgetDialog.setMargin(5)

        self.mainLayout.addWidget(self.widgetDialog)

# Close button
        self.pushButton1 = QPushButton(self,"pushButton1")
        self.pushButton1.setGeometry(QRect(560,330,135,30))
        self.pushButton1.setText(self.__tr("Close"))
        self.connect(self.pushButton1,SIGNAL("clicked()"),self.close)


# Midscale button
        self.pushButton2 = QPushButton(self,"pushButton2")
        self.pushButton2.setGeometry(QRect(560,270,135,30))
        self.pushButton2.setText(self.__tr("Set Midscale"))
        self.connect(self.pushButton2,SIGNAL("clicked()"),self.slotMidScale)


# Iface combobox
        self.comboBoxIface = QComboBox(0,self,"comboBoxIface")
        self.comboBoxIface.setGeometry(QRect(585,170,85,30))
        self.widgetDialog.WirelessStat.device=sys.argv[1]
        self.comboBoxIface.insertItem(self.widgetDialog.WirelessStat.device)
        self.connect(self.comboBoxIface,SIGNAL("activated(int)"),self.ifaceChangedSlot)



# Active interface name

        self.class_path = '/sys/class/net'
        self.findWirelessInterface()


# List of all interface, return first
    def findWirelessInterface(self):

        ''' Finds wireless interface '''
        fileName = 'wireless'
        for interface in os.listdir(self.class_path):
            if os.path.exists(os.path.join(self.class_path, interface, fileName)) and (not interface==self.widgetDialog.WirelessStat.device):

                self.comboBoxIface.insertItem(interface)

# vrs 1.1:
#        iface_lines=self.shellcommand3("cat /proc/net/wireless")#[0:]
#        print "iface_lines, names:"

#        pfilter=re.compile('[-a-z0-9]+:')

#        for line in iface_lines:

#            print line

#            iface_pre=pfilter.search(line)
#            # format:  "iface:", cut ":"
#            try:
#                ifaceName=iface_pre.group()[0:-1].strip()
#                print ifaceName
# kell egy combobox meg:
#                self.comboBoxIface.insertItem(ifaceName)
#            except:
#                print "Line does not dontain iface"
# end vrs 1.1


    def ifaceChangedSlot(self):
        self.widgetDialog.WirelessStat.device=str(self.comboBoxIface.currentText())

    def slotMidScale(self):
        self.axisScale=2*self.widgetDialog.data["LinkQuality"][0]
        if self.axisScale>10:
            print self.axisScale
            self.widgetDialog.setAxisScale(QwtPlot.yLeft, 0, self.axisScale)
        else:
            self.widgetDialog.setAxisScale(QwtPlot.yLeft, 0, 10)


#-----------------------------------------------------------------------------------------
#  extract interface info from shell command output
#-----------------------------------------------------------------------------------------

#    def shellcommand3(self, cmdline):
##        self.cmdline = cmdline
#        sys.stdout.flush()
#        shellin,shellout = os.popen4(cmdline)
#        outputline = shellout.readlines()
#        try:
## vrs 1.1:
#            print outputline
#            return outputline
# end vrs 1.1
#        except:
#            print "NOT FOUND"
#            return "NONE"




    def languageChange(self):
        self.setCaption(self.__tr("Help"))
        self.pushButton1.setText(self.__tr("Close"))


    def __tr(self,s,c = None):
        return qApp.translate("Help",s,c)



def main(args):
    qapptitle=['KWireless Tools Pro 1.2']
    print args
    app=QApplication(qapptitle)
    win=MonitorWindow()
    win.setFixedSize(QSize(700,450))
    win.show()
    app.connect(app, SIGNAL("lastWindowClosed()"), app , SLOT("quit()"))
    app.exec_loop()

if __name__=="__main__":
    main(sys.argv)
